; Azimut Project
; Copyright  2008 Philippe Coulombe. All rights reserved.

.486
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE


.NOLIST
INCLUDE azimut.inc
INCLUDE advapi32.inc
INCLUDE kernel32.inc
.LIST


.DATA

ALIGN 4
szSeDebugPrivilege BYTE "SeDebugPrivilege",0


.CODE

;
; Set debug privilege on the current process access token
;
; Returns non-zero is successful
;
AzmtSetDebugPrivilege PROC

    LOCAL l_hToken:DWORD
    LOCAL l_luid:LUID
    LOCAL l_tp:TOKEN_PRIVILEGES

    invoke LookupPrivilegeValueA, NULL, addr szSeDebugPrivilege, addr l_luid
    test eax, eax
    jz @F

    invoke GetCurrentProcess
    lea ecx, l_hToken
    invoke OpenProcessToken, eax, (TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY), ecx
    test eax, eax
    jz @F

    mov eax, l_luid.LowPart
    mov ecx, l_luid.HighPart
    mov l_tp.PrivilegeCount, 1
    mov l_tp.Privileges.Luid.LowPart, eax
    mov l_tp.Privileges.Luid.HighPart, ecx
    mov l_tp.Privileges.Attributes, SE_PRIVILEGE_ENABLED

    invoke AdjustTokenPrivileges, l_hToken, FALSE, addr l_tp, sizeof l_tp, NULL, NULL
    push eax
    invoke CloseHandle, l_hToken
    pop eax

@@:
    ret

AzmtSetDebugPrivilege ENDP

END
