; Azimut Project
; Copyright  2008 Philippe Coulombe. All rights reserved.

.486
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE


.NOLIST
INCLUDE azimut.inc
INCLUDE kernel32.inc
.LIST


.DATA

ALIGN 4
szSfcDll BYTE "sfc.dll",0

ALIGN 4
szSfcIsFileProtected BYTE "SfcIsFileProtected",0


.CODE

;
; Disable the Windows File Protection on the specified file for 1 minute
; Windows 2000/XP/2003 only
;
; Returns zero if both successful or the file is not protected
;
; p_lpwszFilePath : File path pointer as UNICODE string (Drive\Path\FileName)
;
AzmtWfpFileException PROC p_lpwszFilePath:DWORD

    LOCAL l_hModSfcDll:DWORD
    LOCAL l_dwExitCode:DWORD

    mov l_dwExitCode, 1

    ;
    ; Windows 95/98/ME - version 4
    ; Windows 2000/XP/2003 - version 5
    ; Windows Vista/2008 - version 6
    ;

    invoke GetVersion
    cmp al, 5
    jne @Exit

    ;
    ; Get sfc.dll module handle
    ;

    invoke LoadLibraryA, addr szSfcDll
    test eax, eax
    jz @Exit

    mov l_hModSfcDll, eax

    ;
    ; Get the address of SfcIsFileProtected and call it
    ; Skip the file and succeed if not in the protected list
    ;

    invoke GetProcAddress, l_hModSfcDll, addr szSfcIsFileProtected
    test eax, eax
    jz @FreeLibrary

    push p_lpwszFilePath
    push NULL
    call eax
    mov l_dwExitCode, eax
    test eax, eax
    jz @FreeLibrary

    ;
    ; Get the address of SetSfcFileException (ordinal 5) and call it
    ;

    invoke GetProcAddress, l_hModSfcDll, 5
    test eax, eax
    jz @FreeLibrary

    push -1
    push p_lpwszFilePath
    push 0
    call eax
    mov l_dwExitCode, eax

@FreeLibrary:

    invoke FreeLibrary, l_hModSfcDll

@Exit:

    mov eax, l_dwExitCode
    ret

AzmtWfpFileException ENDP

END
