; Azimut Project
; Copyright  2008 Philippe Coulombe. All rights reserved.

.486
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE


.NOLIST
INCLUDE azimut.inc
INCLUDE kernel32.inc
.LIST


.DATA

ALIGN 4
byThreadProc BYTE 08Bh,044h,024h,004h,0FFh,0D0h,0C2h,004h,000h
;
; 8B442404   mov eax, dword ptr [esp+4]
; FFD0       call eax
; C20400     ret 4
;

ALIGN 4
szWinlogonExe BYTE "winlogon.exe",0

ALIGN 4
szSfcDll BYTE "sfc.dll",0


.CODE

;
; Stop the Windows File Protection until the computer is rebooted
; Windows 2000/XP/2003 only
;
; Returns zero is successful
;
AzmtWfpTerminate PROC

    LOCAL l_hSnap:DWORD
    LOCAL l_pe32:PROCESSENTRY32A
    LOCAL l_hProcess:DWORD
    LOCAL l_hModSfcDll:DWORD
    LOCAL l_lpThreadProc:DWORD
    LOCAL l_hThread:DWORD
    LOCAL l_dwExitCode:DWORD

    mov l_dwExitCode, 1

    ;
    ; Windows 95/98/ME - version 4
    ; Windows 2000/XP/2003 - version 5
    ; Windows Vista/2008 - version 6
    ;

    invoke GetVersion
    cmp al, 5
    jne @Exit

    ;
    ; Search for the winlogon process id
    ;

    invoke CreateToolhelp32Snapshot, TH32CS_SNAPPROCESS, 0
    cmp eax, INVALID_HANDLE_VALUE
    je @Exit

    mov l_hSnap, eax
    mov l_pe32.dwSize, sizeof l_pe32

    invoke Process32First, l_hSnap, addr l_pe32
    test eax, eax
    jz @CloseSnap
    jmp @F

Get_Winlogon:

    invoke Process32Next, l_hSnap, addr l_pe32
    test eax, eax
    jz @CloseSnap

@@:
    invoke lstrcmpiA, addr l_pe32.szExeFile, addr szWinlogonExe
    test eax, eax
    jnz Get_Winlogon

    ;
    ; Set debug privilege on the current process
    ; Open the process we want to get into
    ;

    invoke AzmtSetDebugPrivilege
    test eax, eax
    jz @CloseSnap

    invoke OpenProcess, PROCESS_ALL_ACCESS, FALSE, l_pe32.th32ProcessID
    test eax, eax
    jz @CloseSnap

    mov l_hProcess, eax

    ;
    ; Allocate memory in the target process and write the remote thread procedure
    ;

    invoke VirtualAllocEx, l_hProcess, NULL, sizeof byThreadProc, MEM_COMMIT, PAGE_EXECUTE_READWRITE
    test eax, eax
    jz @CloseProcess

    mov l_lpThreadProc, eax

    invoke WriteProcessMemory, l_hProcess, l_lpThreadProc, addr byThreadProc, sizeof byThreadProc, NULL
    test eax, eax
    jz @FreeMemory

    ;
    ; Get the address of SfcTerminateWatcherThread (ordinal 2) and
    ; pass this address as the remote thread parameter
    ;

    invoke LoadLibraryA, addr szSfcDll
    test eax, eax
    jz @FreeMemory

    mov l_hModSfcDll, eax

    invoke GetProcAddress, eax, 2
    test eax, eax
    jz @FreeLibrary

    invoke CreateRemoteThread, l_hProcess, NULL, 0, l_lpThreadProc, eax, 0, NULL
    test eax, eax
    jz @FreeLibrary

    mov l_hThread, eax

    invoke WaitForSingleObject, l_hThread, INFINITE
    invoke GetExitCodeThread, l_hThread, addr l_dwExitCode

    invoke CloseHandle, l_hThread

@FreeLibrary:

    invoke FreeLibrary, l_hModSfcDll

@FreeMemory:

    invoke VirtualFreeEx, l_hProcess, l_lpThreadProc, 0, MEM_RELEASE

@CloseProcess:

    invoke CloseHandle, l_hProcess

@CloseSnap:

    invoke CloseHandle, l_hSnap

@Exit:

    mov eax, l_dwExitCode
    ret

AzmtWfpTerminate ENDP

END
